"""Add type Sol

Revision ID: 8eb9a12db289
Revises: 5e882af04ff6
Create Date: 2025-05-22 15:36:18.857204

"""

from alembic import op
import sqlalchemy as sa
from sqlalchemy.schema import Table, MetaData
from sqlalchemy.orm.session import Session


# revision identifiers, used by Alembic.
revision = "8eb9a12db289"
down_revision = "5e882af04ff6"
branch_labels = None
depends_on = None


def upgrade():
    metadata = MetaData(bind=op.get_bind())
    nomenclature = Table("t_nomenclatures", metadata, schema="ref_nomenclatures", autoload=True)
    nomenclature_type = Table(
        "bib_nomenclatures_types", metadata, schema="ref_nomenclatures", autoload=True
    )

    op.execute(
        sa.insert(nomenclature_type).values(
            dict(
                mnemonique="TYPE_SOL",
                label_fr="Type de sol",
                label_default="Type de sol",
                definition_fr="",
                source="SINP",
                statut="Validé",
            )
        )
    )
    id_type = sa.func.ref_nomenclatures.get_id_nomenclature_type("TYPE_SOL")
    nomenclatures = [
        dict(
            id_type=id_type,
            cd_nomenclature="1",
            mnemonique="Alocrisols",
            label_fr="Alocrisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Alocrisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="2",
            mnemonique="Andosols",
            label_fr="Andosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Andosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="3",
            mnemonique="Anthroposols",
            label_fr="Anthroposols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Anthroposols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="4",
            mnemonique="Arénosols",
            label_fr="Arénosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Arénosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="5",
            mnemonique="Brunisols",
            label_fr="Brunisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Brunisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="6",
            mnemonique="Solums dont le complexe adsorbant est dominé par le calcium (et/ou le magnésium)",
            label_fr="Solums dont le complexe adsorbant est dominé par le calcium (et/ou le magnésium)",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Solums dont le complexe adsorbant est dominé par le calcium (et/ou le magnésium)",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="7",
            mnemonique="Chernosols",
            label_fr="Chernosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Chernosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="8",
            mnemonique="Colluviosols",
            label_fr="Colluviosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Colluviosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="9",
            mnemonique="Cryosols",
            label_fr="Cryosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Cryosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="10",
            mnemonique="Ferrallitisols et oxydisols",
            label_fr="Ferrallitisols et oxydisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Ferrallitisols et oxydisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="11",
            mnemonique="Ferruginosols",
            label_fr="Ferruginosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Ferruginosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="12",
            mnemonique="Fersialsols",
            label_fr="Fersialsols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Fersialsols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="13",
            mnemonique="Fluviosols",
            label_fr="Fluviosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Fluviosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="14",
            mnemonique="Grisols",
            label_fr="Grisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Grisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="15",
            mnemonique="Gypsosols",
            label_fr="Gypsosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Gypsosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="16",
            mnemonique="Histosols",
            label_fr="Histosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Histosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="17",
            mnemonique="Leptismectisols",
            label_fr="Leptismectisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Leptismectisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="18",
            mnemonique="Lithosols",
            label_fr="Lithosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Lithosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="19",
            mnemonique="Luvisols",
            label_fr="Luvisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Luvisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="20",
            mnemonique="Nitosols",
            label_fr="Nitosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Nitosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="21",
            mnemonique="Organosols",
            label_fr="Organosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Organosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="22",
            mnemonique="Pélosols",
            label_fr="Pélosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Pélosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="23",
            mnemonique="Peyrosols",
            label_fr="Peyrosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Peyrosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="24",
            mnemonique="Phæosols",
            label_fr="Phæosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Phæosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="25",
            mnemonique="Planosols",
            label_fr="Planosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Planosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="26",
            mnemonique="Podzosols",
            label_fr="Podzosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Podzosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="27",
            mnemonique="Rankosols",
            label_fr="Rankosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Rankosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="28",
            mnemonique="Réductisols et rédoxisols",
            label_fr="Réductisols et rédoxisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Réductisols et rédoxisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="29",
            mnemonique="Régosols",
            label_fr="Régosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Régosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="30",
            mnemonique="Salisols et sodisols",
            label_fr="Salisols et sodisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Salisols et sodisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="31",
            mnemonique="Thalassosols",
            label_fr="Thalassosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Thalassosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="32",
            mnemonique="Thiosols et sulfatosols",
            label_fr="Thiosols et sulfatosols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Thiosols et sulfatosols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="33",
            mnemonique="Veracrisols",
            label_fr="Veracrisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Veracrisols",
        ),
        dict(
            id_type=id_type,
            cd_nomenclature="34",
            mnemonique="Vertisols",
            label_fr="Vertisols",
            definition_fr="""""",
            source="SINP",
            statut="Validé",
            id_broader=0,
            hierarchy=None,
            active=True,
            label_default="Vertisols",
        ),
    ]

    for nom in nomenclatures:
        op.execute(sa.insert(nomenclature).values(**nom))


def downgrade():
    metadata = MetaData(bind=op.get_bind())
    session = Session(bind=op.get_bind())

    nomenclature = Table("t_nomenclatures", metadata, schema="ref_nomenclatures", autoload=True)
    nomenclature_type = Table(
        "bib_nomenclatures_types", metadata, schema="ref_nomenclatures", autoload=True
    )

    id_type_nomenclature = session.scalar(
        sa.select(nomenclature_type.c.id_type).where(nomenclature_type.c.mnemonique == "TYPE_SOL")
    )

    op.execute(sa.delete(nomenclature).where(nomenclature.c.id_type == id_type_nomenclature))
    op.execute(sa.delete(nomenclature_type).where(nomenclature_type.c.mnemonique == "TYPE_SOL"))
